void SaveDel(char *Channel);
void ExpireChannels(char *Nick);
OperListType FindBestUserMatch(char *Nick, char *Channel);
OperListType FindBestUserMatchPass(char *Nick, char *Channel);
char *GetInfo(char *Nick, char *Channel);
void SetInfo(char *Nick, char *Channel, char *Info);
void ConvertModeString(char *ModeString, int *PlusModes, int *MinModes,
		       char **Key, char **limit);
int SetMaskNameByHost(char *Mask, char *Channel, char *NewName, int level);
int IsInChan(char *Handle, char *Channel);
time_t GetSeenTime(char *Nick, char *Channel);
void SetLastSeen(char *Nick, char *Channel, int action);
char *GetModeString(char *ModeString, int PlusModes, int MinModes, char *key, char *limit);
void WriteChanOpFile(char *Channel);
OperListType FindOp(OperSegment TheSegment, char *OperAddy);
int AddOp(OperSegment NewOperSeg, char *OperAddy, char *Nick, char *Pass, char *Info, int AutoOp, time_t LastSeen);
int DelUser(OperSegment OpSeg, char *OperAddy, char *Channel, char *Nick);
int FDelUserByHost(OperSegment OpSeg, char *OperAddy, char *Channel, char *Nick);
int DelChan(char *Name);
int AddChan(char *ChanName, char *ModeString, char *ChanTopic,
            char *Description, char *URL, char *ReggedBy,
            int settings[NUMOFCHANSETTINGS],
	    time_t CreationDate, time_t LastAccess,
	    OperSegment NewOperSeg);
OperSegment GetOpSegment(char *Channel);
OperListType GetOpList(char *Nick, char *Channel);
ChannelListType GetChannel(char *Channel);
int IsProt(char *channel, char *hostmask);
boolean IsChanOp(char *Nick, char *Channel);
boolean IsChanManager(char *Nick, char *Channel);
boolean IsChanOwner(char *Nick, char *Channel);
boolean PassOk(char *Nick, char *Channel, char *Pass);
boolean IsValidated(char *Nick, char *Channel);
boolean IsValidatedNode(UserListType UserNode, char *Channel);
boolean ChangePass(char *Nick, char *Channel, char *OldPass, char *NewPass);
void ResetPass(char *Nick, char *Channel);
void ProcessChanMode(char *Nick, char *Channel, char *Modes, char *Arg4, char *Ban);
char *ConvertChanMode(char *StrModes, unsigned char Modes);
#ifdef HYBRIDTS4
void ProcessJoin(char *Nick, char *Chans, char *SJmodes);
#else
void ProcessJoin(char *Nick, char *Chan);
#endif
void ProcessPart(char *Nick, char *Chan);
void UpdateTopic(char *Channel, char *NewTopic);
void UpdateEnforce(char *Channel, int Val);
void UpdateFlood(char *Channel, int Val);
void UpdateMode(char *Channel, int Mode);
void SaveStamp(char *Channel, time_t Stamp);
void FixStamps();
void KillChanList();
BAN_list *search_ban(BAN_list ** b_list, char *banstring);
int channel_unban(char *channel, char *user);
void add_ban(BAN_list ** b_list, char *banstring);
int delete_ban(BAN_list ** b_list, char *banstring);
int channel_massunban(char *channel);

#define CHFL_VOICE  0x0002
#define CHFL_CHANOP 0x0001
#define MODE_CHANOP     CHFL_CHANOP
#define MODE_VOICE      CHFL_VOICE
#define MODE_PRIVATE    0x0004
#define MODE_SECRET     0x0008
#define MODE_MODERATED  0x0010
#define MODE_TOPICLIMIT 0x0020
#define MODE_INVITEONLY 0x0040
#define MODE_NOPRIVMSGS 0x0080
#define MODE_KEY        0x0100
#define MODE_BAN        0x0200
#define MODE_LIMIT      0x0400
#define MODE_FLAGS      0x07ff
