#!/usr/bin/perl

# This script converts X2 4.6 database files into the new 5.0 format.
# It looks for chan.dat and CHANS/* in the current directory, and the
# new files are saved as chan.dat.new and CHANS.NEW/*
# This is my first perl script, so give me a break if
# it looks like I did things the hard way.
#
#
system("mkdir ../CHANS.NEW");
open(CHANDAT, "../chan.dat") or die "../chan.dat not found\n";
open(NEWCHANDAT, ">../chan.dat.new") or die "cannot create ../chan.dat.new\n";
print "Beginning conversion from 4.x data files to 5.0.\n";
print "working..";
while($line = <CHANDAT>)
{
  $line =~ /^(\S+)\s(\d+)\s(\d+)\s(\d+)\s(\d+)\s(\d+)\s(\d+)\s(\d+)\s(\d+)\s(\d+)\s(\d+)\s(\d+)\s(\d+)\s(\d+)\s(\d+)\s([^:]+):([^\n]+)/;
  @piece[1] = $1;
  @piece[2] = $2;
  @piece[3] = $3;
  @piece[4] = $4;
  @piece[5] = $5;
  @piece[6] = $6;
  @piece[7] = $7;
  @piece[8] = $8;
  @piece[9] = $9;
  @piece[10] = $10;
  @piece[11] = $11;
  @piece[12] = $12;
  @piece[13] = $13;
  @piece[14] = $14;
  @piece[15] = $15;
  @piece[16] = $16;
  @piece[17] = $17;
  print ".";

  print NEWCHANDAT "\#$1\n";
  $filename = uc($1);
  $newfilename = "../CHANS.NEW/$filename";
  $oldfilename = "../CHANS/$filename";

  open(NEWCHANFILE, ">$newfilename") or die "Cannot create $filename\n";
  open(CHANFILE, "$oldfilename") or die "Cannot open $filename\n";
  print NEWCHANFILE "VERSION 1\n";
  print NEWCHANFILE "CHANNEL #@piece[1]\n";
  print NEWCHANFILE "TOPIC @piece[17]\n";
  print NEWCHANFILE "DESCRIPTION Not set\n";
  print NEWCHANFILE "WEB *\n";
  print NEWCHANFILE "MODES @piece[16]\n";
# TOPICFREQ STRICTOP AUTOOP *INCHAN *SUSPENDED ENFMODES PASSMODES BANTIMEOUT PROTECT *NODELETE PEONVOICE *USERINFO
  print NEWCHANFILE "SETTINGS @piece[2] @piece[3] @piece[4] 1 0 @piece[7] @piece[8] @piece[9] @piece[10] 0 @piece[12] 1\n";
  print NEWCHANFILE "LASTVISITED @piece[14]\n";
  print NEWCHANFILE "REGEDBY SCRIPT @piece[15]\n";
  while(<CHANFILE>)
  {
# Uncomment this for earlier 5.0 releases that had HELPER instead of MANAGER.
#    s/^M/H/;
    s/^B/L/;
    print NEWCHANFILE "USER $_";
  }
  close(NEWCHANFILE);
  close(CHANFILE);
}
print "\nDone.\n";
